'''
    Copyright 2009, 2010 Oskar Andreasson

    This file is part of pyEveApi.

    pyEveApi is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    pyEveApi is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyEveApi.  If not, see <http://www.gnu.org/licenses/>.

@author: oan
'''
import pickle
import os
import debugger
from datetime import datetime, timedelta

class ApiCacher(object):
    '''
    classdocs
    '''
    cachedUntil = 0

    def _saveCacheXMLJournal(self):
        if not self.isJournalValid():
            raise Exception("Aiee", 2)
        debugger.DBUG(3, "Saving Cache to file: " + self.XMLFile)
        pickles = [self.cachedUntil,self.nodeList]
        file = open(self.XMLFile, "w")
        pickle.dump(pickles, file)
        file.close()
        pass

    def _loadCacheXMLJournal(self):
        debugger.DBUG(3, "Loading Cache from file: " + self.XMLFile)
        file = open(self.XMLFile, "r")
        unpickled = pickle.load(file)
        file.close()
        self.cachedUntil = unpickled[0]
        self.nodeList = unpickled[1]
        pass
            
    def doLoad(self):
        debugger.DBUG(3, "ApiLongCacher::doLoad()")
        self.cachedUntil = datetime.now().replace(year=1900)
        try:
            self._loadCacheXMLJournal()
        except:
            debugger.DBUG(3, "Failed to load cache.")
        
        if not self.isCacheValid():
            try: 
                self.doDownload()
                self.doParse()
                self.doSave()
            except:
                debugger.DBUG(3, "Failed to download new version, keeping old cache")

    def isJournalValid(self):
        if hasattr(self, "nodeList"):
            return True
        else:
            return False
        pass

    def isCacheValid(self):
        if hasattr(self, "nodeList"):
            if self.cachedUntil > datetime.now():
                return True
        return False
    
    def doSave(self):
        try:
            self._saveCacheXMLJournal()
        except () as e:
            print e 
            debugger.DBUG(0, "Failed to save cache!")
            exit()
        pass
    
    def setCacheFile(self, characterid, apitype):
        self.XMLFile = os.path.expanduser("~") + "/.libeveapi/" + apitype + "." + str(characterid) + ".xml"
        debugger.DBUG(3, "Savefile: " + self.XMLFile)
        pass

    def __init__(self, characterid, apitype):
        '''
        Constructor
        '''
        debugger.DBUG(3, "ApiCacher")
        self.setCacheFile(characterid, apitype)
        
