# -*- coding: utf-8 -*-
'''
    Copyright 2009, 2010 Oskar Andreasson

    This file is part of pyEveApi.

    pyEveApi is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    pyEveApi is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyEveApi.  If not, see <http://www.gnu.org/licenses/>.

@author: oan
'''
from ApiLongCacher import ApiLongCacher
import debugger
from datetime import datetime,timedelta

class ApiModifiedLongCacher(ApiLongCacher):
    '''
    classdocs
    '''
    nodeList = []
    def getLatest(self, rows):
        list = self.nodeList
        list.sort( cmp=lambda x,y: cmp(x.getAttribute("transactionDateTime "),
                            y.getAttribute("transactionDateTime")), reverse=True)
        return list[:rows]
    
    def doCleanNodeList(self):
        debugger.DBUG(3, "nodeList Length: " + len(self.nodeList))
        newList = []
        for node in self.nodeList:
            if not node in newList:
                newList.append(node)
        self.nodeList = newList
        debugger.DBUG(3, "nodeList Length: " + len(self.nodeList))
        pass

    def doParse(self):
        debugger.DBUG(3, "ApiModifiedLongCacher::doParse()")
        self.doParseXml()
        if hasattr(self, "ParsedTree"):
            debugger.DBUG(2, "ParsedTree found")
            try: 
                debugger.DBUG(3, "ParsedTree has " + self.ParsedTree.getElementsByTagName("row").length + " elements")
            except: 
                print self.XMLJournal
                print self.ParsedTree
                exit()
            list = [None] * self.ParsedTree.getElementsByTagName("row").length + 1
            index = 0
            for node in self.ParsedTree.getElementsByTagName("row"):
                debugger.DBUG(3, str(index))
                list[index] = self.xmlNodeToListEntry(node)
                index += 1

            self.doCleanNodeList()
            for node in list:
                if node not in self.nodeList:
                    self.nodeList.append(node)
            self.setCachedUntil(self.ParsedTree.getElementsByTagName("cachedUntil")[0].childNodes)
            debugger.DBUG(3, self.cachedUntil)
            return len(list)
        else:
            debugger.DBUG(0, "No ParsedTree!")
            exit()
        pass
    
    def moreToDownload(self):
        pass

    def doLoad(self):
        debugger.DBUG(3, "ApiModifiedLongCacher::doLoad()")
        lastDownload = 0
        self.cachedUntil = datetime.now().replace(year=1900)
        try:
            self._loadCacheXMLJournal()
        except:
            debugger.DBUG(3, "Failed to load cache") 
            
        if not self.isCacheValid():
            while lastDownload < 1000:
                try:
                    self.doDownload()
                    lastDownload = self.doParse()
                    debugger.DBUG(3, "Succeeded loading more data")
                except:
                    debugger.DBUG(3, "Failed to load more data")
                    break
        self.doSave()

    def __init__(self, userid, apikey, characterid, apiPath, apiName):
        '''
        Constructor
        '''
        debugger.DBUG(3, "ApiModifiedLongCacher")
        ApiLongCacher.__init__(self, userid, apikey, characterid, apiPath, apiName)
