'''
    Copyright 2009, 2010 Oskar Andreasson

    This file is part of pyEveApi.

    pyEveApi is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    pyEveApi is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyEveApi.  If not, see <http://www.gnu.org/licenses/>.

@author: oan
'''
from ApiCacher import ApiCacher
from ApiLogin import ApiLogin
from ApiDownloader import ApiDownloader
from ApiParser import ApiParser
import debugger

class ApiModifiedShortCacher(ApiParser, ApiLogin, ApiDownloader, ApiCacher):
    '''
    classdocs
    '''
    def doParse(self):
        debugger.DBUG(3, "ApiShortCacher::doParse()")        
        self.doParseXml()
        if hasattr(self, "ParsedTree"):
            list = [None] * self.ParsedTree.getElementsByTagName("row").length
            index = 0
            for node in self.ParsedTree.getElementsByTagName("row"):
                list[index] = self.xmlNodeToListEntry(node)
                index += 1
        else:
            debugger.DBUG(2, "Could not find ParsedTree!")
        self.nodeList = list
        self.setCachedUntil(self.ParsedTree.getElementsByTagName("cachedUntil")[0].childNodes)

    def __init__(self, userid, apikey, characterid, apiPath, apiName):
        '''
        Constructor
        '''
        debugger.DBUG(3, "ApiShortCacher")
        ApiLogin.__init__(self, userid, apikey, characterid)
        ApiDownloader.__init__(self, apiPath)
        ApiCacher.__init__(self, characterid, apiName) 
