'''
    Copyright 2009, 2010 Oskar Andreasson

    This file is part of pyEveApi.

    pyEveApi is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    pyEveApi is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyEveApi.  If not, see <http://www.gnu.org/licenses/>.

@author: oan
'''
import xml.dom.minidom
import debugger
from datetime import datetime, timedelta

class ApiParser(object):
    '''
    classdocs
    '''
    
    def doParseXml(self):
        debugger.DBUG(3, "Parse XML")
        if hasattr(self, "XMLJournal"):
            temp = xml.dom.minidom.parseString(self.XMLJournal)
        else:
            debugger.DBUG(3, "aieeee.")
            
        if temp.getElementsByTagName("error").length == 0:
            debugger.DBUG(3, "ParsedTree set")
            self.ParsedTree = temp
        else:
            debugger.DBUG(2, self.getText(temp.getElementsByTagName("error")[0].childNodes))
            raise Exception("Error", temp.getElementsByTagName("error")[0].getAttribute("code"))
        pass
    
    def setCachedUntil(self, element):
        self.cachedUntil = datetime.strptime(
                        self.getText(element),
                        "%Y-%m-%d %H:%M:%S") + timedelta(hours=1)
        pass

    def getText(self, nodelist):
        rc = ""
        for node in nodelist:
            if node.nodeType == node.TEXT_NODE:
                rc = rc + node.data
        return rc

    def __init__(self):
        '''
        Constructor
        '''
        debugger.DBUG(3, "ApiParser")
        try:
            if hasattr(self, "XMLJournal") and not hasattr(self, "ParsedTree"):
                self.doParseXml()
        except Exception as e:
            debugger.DBUG(1, repr(e.args))
            x,y = e
            debugger.DBUG(2, "Error " + y)
            exit()
 
