'''
    Copyright 2009, 2010 Oskar Andreasson

    This file is part of pyEveApi.

    pyEveApi is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    pyEveApi is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyEveApi.  If not, see <http://www.gnu.org/licenses/>.

@author: oan
'''
from ApiLongCacher import ApiLongCacher
import debugger

class IndustryJobs(ApiLongCacher):
    '''
    classdocs
    '''
    def getProductionJobsByFinishTime(self, rows=50):
        list = self.nodeList
        list.sort( cmp=lambda x,y: cmp(x["endProductionTime"],
                            y["endProductionTime"]), reverse=True)
        return list[:rows]

    def getMEResearchJobsByFinishTime(self):
        # TODO
        pass

    def getPEResearchJobsByFinishTime(self):
        # TODO
        pass

    def xmlNodeToListEntry(self, node):
        # jobID assemblyLineID containerID installedItemID installedItemLocationID installedItemQuantity
        # installedItemProductivityLevel installedItemMaterialLevel
        # installedItemLicensedProductionRunsRemaining outputLocationID installerID runs
        # licensedProductionRuns installedInSolarSystemID containerLocationID materialMultiplier
        # charMaterialMultiplier timeMultiplier charTimeMultiplier installedItemTypeID outputTypeID
        # containerTypeID installedItemCopy completed completedSuccessfully installedItemFlag outputFlag
        # activityID completedStatus installTime beginProductionTime endProductionTime pauseProductionTime
        return { 'jobID': node.getAttribute("jobID"),
            'assemblyLineID': node.getAttribute("assemblyLineID"),
            'containerID': node.getAttribute("containerID"),
            'installedItemID': node.getAttribute("installedItemID"),
            'installedItemLocationID': node.getAttribute("installedItemLocationID"),
            'installedItemQuantity': node.getAttribute("installedItemQuantity"),
            'installedItemProductivityLevel': node.getAttribute("installedItemProductivityLevel"),
            'installedItemMaterialLevel': node.getAttribute("installedItemMaterialLevel"),
            'installedItemLicensedProductionRunsRemaining': node.getAttribute("installedItemLicensedProductionRunsRemaining"),
            'outputLocationID': node.getAttribute("outputLocationID"),
            'installerID': node.getAttribute("installerID"),
            'runs': node.getAttribute("runs"),
            'licensedProductionRuns': node.getAttribute("licensedProductionRuns"),
            'installedInSolarSystemID': node.getAttribute("installedInSolarSystemID"),
            'containerLocationID': node.getAttribute("containerLocationID"),
            'materialMultiplier': node.getAttribute("materialMultiplier"),
            'charMaterialMultiplier': node.getAttribute("charMaterialMultiplier"),
            'timeMultiplier': node.getAttribute("timeMultiplier"),
            'charTimeMultiplier': node.getAttribute("charTimeMultiplier"),
            'installedItemTypeID': node.getAttribute("installedItemTypeID"),
            'outputTypeID': node.getAttribute("outputTypeID"),
            'containerTypeID': node.getAttribute("containerTypeID"),
            'installedItemCopy': node.getAttribute("installedItemCopy"),
            'completed': node.getAttribute("completed"),
            'completedSuccessfully': node.getAttribute("completedSuccessfully"),
            'installedItemFlag': node.getAttribute("installedItemFlag"),
            'outputFlag': node.getAttribute("outputFlag"),
            'activityID': node.getAttribute("activityID"),
            'completedStatus': node.getAttribute("completedStatus"),
            'installTime': node.getAttribute("installTime"),
            'beginProductionTime': node.getAttribute("beginProductionTime"),
            'endProductionTime': node.getAttribute("endProductionTime"),
            'pauseProductionTime': node.getAttribute("pauseProductionTime")
            }

        pass

    def __init__(self, userid, apikey, characterid):
        '''
        Constructor
        '''
        debugger.DBUG(3, "IndustryJobs")
        ApiLongCacher.__init__(self, userid, apikey, characterid, "/char/IndustryJobs.xml.aspx", "IndustryJobs")
        self.doLoad()
