'''
    Copyright 2009, 2010 Oskar Andreasson

    This file is part of pyEveApi.

    pyEveApi is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    pyEveApi is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyEveApi.  If not, see <http://www.gnu.org/licenses/>.

@author: oan
'''
from ApiParser import ApiParser
import pickle
import debugger
import sys, os

class ItemDB(ApiParser):
    '''
    classdocs
    '''
    def _doSaveCache(self):
        debugger.DBUG(3, "Saving cachefile " + self.CacheFile)
        pickles = [self.Items]
        file = open(self.CacheFile, "w")
        pickle.dump(pickles, file)
        file.close()
        pass
    
    def _doLoadCache(self):
        debugger.DBUG(3, "Loading cachefile " + self.CacheFile)
        file = open(self.CacheFile, "r")
        unpickled = pickle.load(file)
        file.close()
        self.Items = unpickled[0]
        pass
        
    def _doLoadXML(self):
        debugger.DBUG(3, "Loading xml file: " + self.XMLFile)
        file = open(self.XMLFile, "r")
        self.XMLJournal = file.read()
        file.close()
        pass
    
    def doLoad(self):
        try:
            self._doLoadCache()
        except:
            self._doLoadXML()
            self.doParseXml()
            self.doParse()
            self._doSaveCache()
        pass

    def doParse(self):
        list = self.ParsedTree.getElementsByTagName("item")
        self.Items = [None] * (int(list.item(list.length-1).getAttribute("id"))+1)
        for node in self.ParsedTree.getElementsByTagName("item"):
            if node.nodeType == node.ELEMENT_NODE:
                self.Items[int(node.getAttribute("id"))] =  node.getAttribute("name")
            pass
        pass
    
    def getName(self, id):
        return self.Items[id]

    def __init__(self):
        '''
        Constructor
        '''
        debugger.DBUG(3, "ItemDB")
        for path in sys.path:
            if os.path.isfile(os.path.join(path, "pyEveApi/data/typeid.xml")):
                self.XMLFile = os.path.join(path, "pyEveApi/data/typeid.xml")
                debugger.DBUG(4, "Set itemdb xml " + self.XMLFile)
            if os.path.isfile(os.path.join(path, "pyEveApi/data/typeid.cache")):
                self.CacheFile = os.path.join(path, "pyEveApi/data/typeid.cache")
                debugger.DBUG(4, "Set itemdb cache " + self.CacheFile)
        # If we failed to find a system wide cache, use a "per user" version
        if not hasattr(self, "CacheFile"):
            self.CacheFile = os.path.expanduser("~") + "/.libeveapi/" + "typeid.cache"
            debugger.DBUG(4, "Set itemdb cache " + self.CacheFile)
            pass
        self.doLoad()
