'''
    Copyright 2009, 2010 Oskar Andreasson

    This file is part of pyEveApi.

    pyEveApi is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    pyEveApi is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyEveApi.  If not, see <http://www.gnu.org/licenses/>.

@author: oan
'''
from ApiLongCacher import ApiLongCacher
import debugger
import ItemDB

class MarketOrders(ApiLongCacher):
    '''
    classdocs
    '''

    def getSellOrdersByName(self, itemDb):
        # Copy to list
        list = self.nodeList
        # Remove unwanted elements
        list = filter(lambda x: not bool(int(x['bid'])), list)
        list = filter(lambda x: int(x["volRemaining"]) > 0, list)
        list = filter(lambda x: int(x["orderState"]) == 0, list)
        # Sort elements by name
        list.sort( cmp=lambda x,y: cmp(itemDb.getName(int(x["typeID"])),
                                        itemDb.getName(int(y["typeID"]))), 
                                        reverse=False)
        return list

    def getBuyOrdersByName(self, itemDb):
        # Copy to list
        list = self.nodeList
        # Remove unwanted elements
        list = filter(lambda x: bool(int(x["bid"])), list)
        list = filter(lambda x: int(x["volRemaining"]) > 0, list)
        list = filter(lambda x: int(x["orderState"]) == 0, list)
        # Sort elements by name
        list.sort( cmp=lambda x,y: cmp(itemDb.getName(int(x["typeID"])),
                                        itemDb.getName(int(y["typeID"]))), 
                                        reverse=False)
        return list
    
    def xmlNodeToListEntry(self, node):
        # orderID charID stationID volEntered volRemaining minVolume orderState typeID range accountKey
        # duration escrow price bid issued
        return {'orderID': node.getAttribute("orderID"), 
                    'charID': node.getAttribute("charID"),
                    'stationID': node.getAttribute("stationID"),
                    'volEntered': node.getAttribute("volEntered"),
                    'volRemaining': node.getAttribute("volRemaining"),
                    'minVolume': node.getAttribute("minVolume"),
                    'orderState': node.getAttribute("orderState"),
                    'typeID': node.getAttribute("typeID"),
                    'range': node.getAttribute("range"),
                    'accountKey': node.getAttribute("accountKey"),
                    'duration': node.getAttribute("duration"),
                    'escrow': node.getAttribute("escrow"),
                    'price': node.getAttribute("price"),
                    'bid': node.getAttribute("bid"),
                    'issued': node.getAttribute("issued")
                    }
        pass

    def __init__(self, userid, apikey, characterid):
        '''
        Constructor
        '''
        debugger.DBUG(3, "MarketOrders")
        ApiLongCacher.__init__(self, userid, apikey, characterid, "/char/MarketOrders.xml.aspx", "MarketOrders")
        self.doLoad()
