'''
    Copyright 2009, 2010 Oskar Andreasson

    This file is part of pyEveApi.

    pyEveApi is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    pyEveApi is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyEveApi.  If not, see <http://www.gnu.org/licenses/>.

@author: oan
'''
from ApiShortCacher import ApiShortCacher
import debugger

class SkillInTraining(ApiShortCacher):
    '''
    classdocs
    '''
    def getSkillName(self, items):
        if self.nodeList != None:
            return items.getName(int(self.nodeList['trainingTypeID']))
        else:
            return None
    
    def getToLevel(self):
        if self.nodeList != None:
            return self.nodeList['trainingToLevel']
        else:
            return None
    
    def getTrainingStartTime(self):
        if self.nodeList != None:
            return self.nodeList['trainingStartTime']
        else:
            return None
    
    def getTrainingEndTime(self):
        if self.nodeList != None:
            return self.nodeList['trainingEndTime']
        else:
            return None
        
    # SkillInTraining does not follow the other patterns, have to rewrite doParse
    def doParse(self):
        debugger.DBUG(3, "SkillInTraining::doParse()")        
        self.doParseXml()
        if hasattr(self, "ParsedTree"):
            if self.getText(self.ParsedTree.getElementsByTagName("skillInTraining")[0].childNodes) != "0":
                list = {'currentTQTime': self.getText(self.ParsedTree.getElementsByTagName("currentTQTime")[0].childNodes),
                              'trainingEndTime': self.getText(self.ParsedTree.getElementsByTagName("trainingEndTime")[0].childNodes),
                              'trainingStartTime': self.getText(self.ParsedTree.getElementsByTagName("trainingStartTime")[0].childNodes),
                              'trainingTypeID': self.getText(self.ParsedTree.getElementsByTagName("trainingTypeID")[0].childNodes),
                              'trainingStartSP': self.getText(self.ParsedTree.getElementsByTagName("trainingStartSP")[0].childNodes),
                              'trainingToLevel': self.getText(self.ParsedTree.getElementsByTagName("trainingToLevel")[0].childNodes),
                              'skillInTraining': self.getText(self.ParsedTree.getElementsByTagName("skillInTraining")[0].childNodes)}
            else:
                list = None
            pass
        else:
            debugger.DBUG(2, "Could not find ParsedTree!")
        self.nodeList = list
        self.setCachedUntil(self.ParsedTree.getElementsByTagName("cachedUntil")[0].childNodes)

    def __init__(self, userid, apikey, characterid=0):
        '''
        Constructor
        '''
        debugger.DBUG(3, "SkillInTraining")
        ApiShortCacher.__init__(self, userid, apikey, characterid, "/char/SkillInTraining.xml.aspx", "SkillInTraining")
        self.doLoad()