'''
    Copyright 2009, 2010 Oskar Andreasson

    This file is part of pyEveApi.

    pyEveApi is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    pyEveApi is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyEveApi.  If not, see <http://www.gnu.org/licenses/>.

@author: oan
'''
from ApiModifiedLongCacher import ApiModifiedLongCacher
import debugger


class WalletTransaction(ApiModifiedLongCacher):
    '''
    classdocs
    '''
    def getLatest(self, rows):
        list = self.nodeList
        list.sort( cmp=lambda x,y: cmp(x["transactionDateTime"],
                            y["transactionDateTime"]), reverse=True)
        return list[:rows]
    
    def xmlNodeToListEntry(self, node):
        # transactionDateTime transactionID quantity typeName typeID price clientID clientName stationID
        # stationName transactionType transactionFor
        return {
            'transactionDateTime': node.getAttribute("transactionDateTime"),
            'transactionID': node.getAttribute("transactionID"),
            'quantity': node.getAttribute("quantity"),
            'typeName': node.getAttribute("typeName"),
            'typeID': node.getAttribute("typeID"),
            'price': node.getAttribute("price"),
            'clientID': node.getAttribute("clientID"),
            'clientName': node.getAttribute("clientName"),
            'stationID': node.getAttribute("stationID"),
            'stationName': node.getAttribute("stationName"),
            'transactionType': node.getAttribute("transactionType"),
            'transactionFor': node.getAttribute("transactionFor")
            }

        return
        pass

    def __init__(self, userid, apikey, characterid):
        '''
        Constructor
        '''
        debugger.DBUG(3, "WalletTransactions Starting")
        ApiModifiedLongCacher.__init__(self, userid, apikey, characterid, "/char/WalletTransactions.xml.aspx", "WalletTransactions")
        self.doLoad()
